#include <windows.h>

#include <stdio.h>

typedef  const unsigned char  PDCSSF;  // Pdc Serial Signal Format

PDCSSF UP_MD_INFO_W_R	= 0xb1; // _CA񏑍v
PDCSSF UP_PW_VERIFY_R	= 0x01; // Ïؔԍƍv
PDCSSF UP_WRITE_R_A		= 0x02; // ݗv(AhXwȂ)
PDCSSF UP_WRITE_R_B		= 0x0a; // ݗv(AhXw)
PDCSSF UP_ALL_CLEAR_R	= 0x03; // ꊇv
PDCSSF UP_MD_INFO_R_R	= 0xb3; // _CǏov
PDCSSF UP_READ_R		= 0x02; // Ǐov

PDCSSF UP_DIAL_END		= 0x86; // _C
PDCSSF UP_MD_NO_SPECIFY_SEND_R = 0xb2; // _CNo.w蔭Mv
//PDCSSF UP_PW_VERIFY_R	= 0x01; // Ïؔԍƍv
PDCSSF UP_SEND_R		= 0x02;	// Mv
PDCSSF UP_RESERVED		= 0;    // \
PDCSSF UP_F_SW_START	= 0xa5; // tbNXCb`Jn


PDCSSF DW_MF_INFO_N		= 0xa5; // _Cʒm(notify)
PDCSSF DW_PW_A			= 0x86;	// Ïؔԍt(accept)
PDCSSF DW_PW_D			= 0x87;	// Ïؔԍ(deny)
PDCSSF DW_ALL_CLAER_END	= 0x09;	// ꊇ
PDCSSF DW_END_ABNORMAL	= 0x07;	// ُI
PDCSSF DW_END_NORMAL	= 0x06; // I


PDCSSF UD_D0 = 0x9a;
PDCSSF UD_D1 = 0x91;
PDCSSF UD_D2 = 0x92;
PDCSSF UD_D3 = 0x93;
PDCSSF UD_D4 = 0x94;
PDCSSF UD_D5 = 0x95;
PDCSSF UD_D6 = 0x96;
PDCSSF UD_D7 = 0x97;
PDCSSF UD_D8 = 0x98;
PDCSSF UD_D9 = 0x99;

PDCSSF UD_DA = 0x9d;
PDCSSF UD_DB = 0x9e;
PDCSSF UD_DC = 0x9f;
PDCSSF UD_DD = 0x90;
PDCSSF UD_Daster = 0x9b;
PDCSSF UD_Dsharp = 0x9c;

char dial_table[16] = {
	'D','1','2','3','4','5','6','7',
	'8','9','0','*','#','A','B','C'
};

int main (int argc,char *argv[])
{
	DCB dcb;
	HANDLE fh = CreateFile(
		"COM1",
		GENERIC_READ | GENERIC_WRITE,
		0,    // comm devices must be opened w/exclusive-access 
		NULL, // no security attributes
		OPEN_EXISTING, // comm devices must use OPEN_EXISTING
		0,    // not overlapped I/O
		NULL  // hTemplate must be NULL for comm devices
		);

	if ( fh == INVALID_HANDLE_VALUE ) {
		printf("can't open COM1");
		return 1;
	}
	printf("handle : %d\n",fh);

	if ( !GetCommState(fh, &dcb) ){
		CloseHandle(fh);
		printf("GetCommState error\n");
		return 1;
	}
	
	dcb.BaudRate = 600;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	
	if ( !SetCommState(fh, &dcb) ) {
		CloseHandle(fh);
		printf("SetCommState error\n");
		return 1;
	}

	int befor_db = 0;
	char buff[1024];
	while(1){
		int ic;
		DWORD nobr;
		ReadFile(fh,&ic,1,&nobr,NULL);

		BYTE c = ic;

		buff[0] = '\0';

		if ( (c & 0xf0) == 0xc0 ) {
			int db = (c&15);
			if ( db != befor_db ) {
				printf("\ndgx %2d ",db);
				befor_db = db;
			}
			else {
				printf("X ");
			}
		}
		else if ( (c & 0xf0) == 0x90 ) {
			printf("\n_C%c ",dial_table[(c-0x90)&0xf]);
		}
		else if ( c == 0x80 ) printf("\n ");
		else if ( c == 0x81 ) printf("\nO ");
		else if ( c == 0x82 ) printf("\nۗ\ off ");
		else if ( c == 0x83 ) printf("\nۗ\ on ");
		else if ( c == 0x8a ) printf("\nMK\ on ");
		else if ( c == 0x8b ) printf("\nMK\ off ");
		else if ( c == 0x8e ) printf("\n_CbN\ off ");
		else if ( c == 0x8f ) printf("\n_CbN\ on ");
		else if ( c == 0xa2 ) printf("\ndrdቺx\ ");
		else if ( c == 0xa3 ) printf("\nuZbg\ ");
		else if ( c == 0xa4 ) printf("\nM\ off ");
		else if ( c == 0xa5 ) printf("\nM\ on ");
		else if ( c == 0xa6 ) printf("\nʘb\ off ");
		else if ( c == 0xa7 ) printf("\nʘb\ on ");
		else if ( c == 0xa8 ) printf("\ng(not ԍ) ");
		else if ( c == 0xa9 ) printf("\nԍ(not g) ");
		else if ( c == 0xaa ) printf("\n_C ");
		else if ( c == 0xab ) printf("\n_C ");
		else if ( c == 0xae ) printf("\ndrd񕜕\ ");
		else if ( c == 0xaf ) printf("\nҎ ");
		else if ( c == 0xeb ) printf("\n[~O OFF ");
		else if ( c == 0xec ) printf("\n[~O  ");
		else if ( c == 0xed ) printf("\n[~O  ");

		else if ( c == 0xad ) {
			int retrymax = 0;
			unsigned long netinfo=0;
			printf("\nԏ (Ԕԍ) : ");
			for ( int ii=0;ii<4;ii++){
				ReadFile(fh,&ic,1,&nobr,NULL);
				c = ic;
				if(c>0xf){
					if ( retrymax++ == 8 ) break;
				}
				netinfo <<= 4;
				netinfo += c;
			}
			if ( ii==4 ){
				printf("%04X ",netinfo);
			}
		}
		else {
			printf("%02X ",c);
		}
	}
	CloseHandle(fh);
	return 0;
}
